
Foreman - Bug #36942

Unable to enable back puppet plugin again after completely purging the puppet plugin and related

stuff 

11/23/2023 06:21 PM - Sayan Das

Status: Ready For Testing   

Priority: Normal   

Assignee: Sayan Das   

Category: DB migrations   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: No Found in Releases: 3.1.1, 3.1.2, 3.1.3, 3.2.0, 3.2.1, 3.2.2,

3.3.0, 3.3.1, 3.3.2, 3.4.0, 3.4.1, 3.4.2,

3.5.0, 3.5.1, 3.5.2, 3.5.3, 3.5.4, 3.6.0,

3.6.1, 3.6.2, 3.7.0

Bugzilla link: 2087067 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/9918

  

Description

If we have used "foreman-maintain plugin purge-puppet -f" to disable puppet plugin , It has invoked "foreman-rake purge:puppet" and

attempted to delete the required tables\columns\migrations.

But we cannot enable back the plugin and installer is not able to find all required tables or table relations to make it work.

The very first step it fails is on the db:migrate i.e.

2022-05-17 04:45:47 [NOTICE] [configure] 1250 configuration steps out of 2097 steps complete.

2022-05-17 04:46:39 [ERROR ] [configure] '/usr/sbin/foreman-rake db:migrate' returned 1 instead of one of [0]

2022-05-17 04:46:39 [ERROR ] [configure]

/Stage[main]/Foreman::Database/Foreman::Rake[db:migrate]/Exec[foreman-rake-db:migrate]/returns: change from 'notrun' to ['0']

failed: '/usr/sbin/foreman-rake db:migrate' returned 1 instead of one of [0]

2022-05-17 04:47:04 [NOTICE] [configure] 1500 configuration steps out of 2097 steps complete.

2022-05-17 04:47:08 [NOTICE] [configure] 1750 configuration steps out of 2901 steps complete.

...

1. /usr/sbin/foreman-rake db:migrate

20121018152459 CreateHostgroupClasses: migrating =========================

-- rename_table(:hostgroups_puppetclasses, :hostgroup_classes)

rake aborted!

StandardError: An error has occurred, this and all later migrations canceled:

PG::UndefinedTable: ERROR:  relation "hostgroups_puppetclasses" does not exist

/opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.4.7/lib/active_record/connection_adapters/postgresql/database_state

ments.rb:92:in `async_exec'

/opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.4.7/lib/active_record/connection_adapters/postgresql/database_state

ments.rb:92:in `block (2 levels) in execute'

/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.4.7/lib/active_support/dependencies/interlock.rb:48:in `block in

permit_concurrent_loads'

/opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.4.7/lib/active_support/concurrency/share_lock.rb:187:in

`yield_shares'

For more details and the detailed investigation done, please refer to https://bugzilla.redhat.com/show_bug.cgi?id=2087067

History

#1 - 11/23/2023 06:29 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/9918 added
